""" Addon Information """
# ------------
# EventScripts Script-Addon:    BEWar (bewar.py, 10.3kb)
# Author:                       BackRaw - http://forums.eventscripts.com/profile.php?mode=viewprofile&u=13683
#                                         http://addons.eventscripts.com/addons/user/13683
# Version:                      2.0
# ------------

""" Imports """
# ------------
# EventScripts Core Module              - ES functionality
import es
# Popuplib                              - Create popups
import popuplib
# Gamethread                            - Delayed functions
from gamethread import delayed
# Config Object                         - Configuration File
from configobj import ConfigObj
# Time                                  - Current time
from time import strftime
# OS                                    - Directory listing
from os import listdir
# ------------

""" Global Variables """
# ------------
# This will hold the Prefix of BEWar in a variable.
# We'll need the same string often, a global variable is the best for that.
# ------------
prefix = '#green[#lightgreenBEWar#green] #default'

""" Classes """
# ------------
# This class holds War-Information, such as Team 1 Wins and Team 2 Wins, Max Rounds and so on...
# ------------
class War(object):
    def __init__(self):
        self.wins = {'1':0, '2':0}
        self.team1, self.team2 = 1, 2
        self.mr = 12
        self.second = 0
        self.wartype = 0
        self.announce = 0
    # Live on 3 wrapper - Uses ZB's method if ZB is installed.
    def lo3(self):
        if es.exists('variable', 'zb_ver'):
            es.server.queuecmd('zb_lo3')
        else:
            es.server.queuecmd('mp_restartgame 1')
            delayed(1.5, es.msg, ('#multi', '%sRestart 1' % prefix))
            es.delayed(2, 'mp_restartgame 1')
            delayed(3.5, es.msg, ('#multi', '%sRestart 2' % prefix))
            es.delayed(4, 'mp_restartgame 1')
            delayed(5.5, es.msg, ('#multi', '%sRestart 3 - #green%s!' % (prefix, ('MATCH IS LIVE' if self.wartype == 1 else 'KNIVES'))))
    # Reset wins...
    def reset(self):
        for x in self.wins:
            self.wins[x] = 0
    # Change teams and hit Live on 3 again...
    def changeTeams(self):
        self.lo3()
        for x in es.getUseridList():
            es.changeteam(x, 2 if es.getplayerteam(x) == 3 else 3)
    # round_end
    def addWin(self, winner):
        if self.wartype:
            if self.team1 == 1:
                if winner == '2':
                    self.wins['1'] += 1
                else:
                    self.wins['2'] += 1
            else:
                if winner == '2':
                    self.wins['2'] += 1
                else:
                    self.wins['1'] += 1
            wins1, wins2 = self.wins['1'], self.wins['2']
            if wins1 > wins2:
                winner = 1
            elif wins1 < wins2:
                winner = 2
            else:
                winner = 0
            if self.announce:
                if winner:
                    es.msg('#multi', '%s#greenTeam %s #defaultwon the match - Score: #lightgreen%s - %s' % (prefix, winner, wins1, wins2))
                else:
                    winner = '%sNo Team won: #lightgreen%s - %s' % (prefix, wins1, wins2)
            if not self.second and wins1 + wins2 == self.mr:
                if winner:
                    winner = '%s#greenTeam %s #defaultwon - Score: #lightgreen%s - %s' % (prefix, winner, wins1, wins2)
                else:
                    winner = '%sNo Team won: #lightgreen%s - %s' % (prefix, wins1, wins2)
                self.second = 1
                self.team1, self.team2 = 2, 1
                delayed(1.5, self.changeTeams)
                delayed(2, es.msg, ('#multi', winner))
            elif self.second:
                if wins1 == self.mr + 1:
                    winner = 2
                elif wins2 == self.mr + 1:
                    winner = 1
                if winner in [1, 2]:
                    if winner == 1:
                        winner = 'Team 2'
                    elif winner == 2:
                        winner = 'Team 1'
                    else:
                        winner = 'No Team'
                    es.msg('#multi', '%s#greenTeam %s #defaultwon the match - Score: #lightgreen%s - %s' % (prefix, winner, wins1, wins2))
                    es.msg('#multi', "%sToday's Date: #lightgreen%s #default- #greenGood Game!" % (prefix, strftime('%d.%m.%Y - %H:%M')))
                    self.wartype = 0
war = War()

# ------------
# This class is just a wrapper for specific functions...
# ------------
class Player(object):
    def __init__(self, userid):
        self.userid = userid
    def fire(self, cmd):
        es.server.queuecmd('es_xfire %s %s' % (self.userid, cmd))
    def give(self, cmd):
        es.server.queuecmd('es_xgive %s %s' % (self.userid, cmd))
    def funcs(self, arg):
        arg = arg.capitalize()
        self.fire('func_buyzone %s' % arg)
        self.fire('func_bomb_target %s' % arg)
        self.fire('func_hostage_rescue %s' % arg)
    def strip(self):
        self.fire('player_weaponstrip Kill')
        self.give('player_weaponstrip')
        self.fire('player_weaponstrip Strip')
        self.give('item_assaultsuit')
        delayed(0, self.give, 'weapon_knife')

def player(userid):
    if es.exists('userid', userid):
        return Player(userid)
    raise TypeError, 'UserID %s does not exist!' % userid

""" Events """

# ------------
# If Ko3 is started, disable buying functions, and only give a knife.
# Else - normal gameplay again.
# ------------
def player_spawn(ev):
    pl = player(ev['userid'])
    if war.wartype == 2:
        pl.funcs('disable')
        pl.strip()
    elif war.wartype == 1:
        pl.funcs('enable')

# ------------
# Counts the round up to the Max Rounds...
# ------------
def round_end(ev):
    winner = ev['winner']
    if winner in ['2', '3']:
        if war.wartype == 1:
            war.addWin(winner)
        elif war.wartype == 2:
            es.msg('#multi', '%s#green%s #defaultwon the Knife-Fight, choose a team...' % (prefix, winner.replace('2', 'Terrorists').replace('3', 'Counter-Terrorists')))

""" Menus """
# ------------
# This little function handles menus.
# It explains itself, I hope ;)
# ------------
def menuSelect(userid, choice, popupid):
    def subMenu(userid, choice, popupid):
        es.server.queuecmd('exec %s' % choice)
        menu.send(userid)
    def subMR(userid, choice, popupid):
        if choice in [1, 2]:
            if choice == 1:
                if war.mr == 12:
                    war.mr = 15
                elif war.mr == 15:
                    war.mr = 12
                sub.modline(4, '->1. Max Rounds: %s' % war.mr)
                sub.send(userid)
            elif choice == 2:
                es.msg('#multi', '%sMax Rounds were changed to #green%s' % (prefix, war.mr))
                menu.send(userid)
        else:
            sub.send(userid)
    def subOptions(userid, choice, popupid):
        if choice in [1, 2]:
            if choice == 1:
                if not war.announce:
                    war.announce = 1
                elif war.announce:
                    war.announce = 0
                sub.modline(4, '->1. Announce Score each round-end? - %s' % str(war.announce).replace('1', 'On').replace('0', 'Off'))
                sub.send(userid)
            else:
                es.msg('#multi', '%sScoring will #green%s#lightgreenbe announced every round-end#default.' % (prefix, str(war.announce).replace('1', '').replace('0', 'not ')))
                menu.send(userid)
        else:
            sub.send(userid)
    global sub
    name = 'bewar_submenu'
    if popuplib.exists(name):
        popuplib.delete(name)
    if choice == 1:
        sub = popuplib.create(name)
        sub.addline('BEWar - Max Rounds')
        sub.addline('------------')
        sub.addline(' ')
        sub.addline('->1. Max Rounds: %s' % war.mr)
        sub.addline('->2. Save')
        sub.addline(' ')
        sub.addline('0. Close')
        sub.menuselect = subMR
        sub.send(userid)
    elif choice == 2:
        sub = popuplib.easymenu(name, '_popup_choice', subMenu)
        sub.settitle('BEWar - Execute Configs')
        for x in listdir(es.ServerVar('eventscripts_gamedir') + '/cfg'):
            if x.endswith('.cfg'):
                sub.addoption(x, x)
        sub.send(userid)
    elif choice in [3, 4]:
        war.wartype = 2 if choice == 3 else 1
        war.reset()
        war.lo3()
    elif choice == 5:
        sub = popuplib.create(name)
        sub.addline('BEWar - Change Options')
        sub.addline('------------')
        sub.addline(' ')
        sub.addline('->1. Announce Score each round-end? - %s' % str(war.announce).replace('1', 'On').replace('0', 'Off'))
        sub.addline('->2. Save')
        sub.addline(' ')
        sub.addline('0. Close')
        sub.menuselect = subOptions
        sub.send(userid)

""" Client Command 'admin' """
# ------------
# Checks if the player is an Admin, if so, send him/her the menu.
# ------------
def admin():
    userid = es.getcmduserid()
    if es.getplayersteamid(userid) in ConfigObj(es.getAddonPath('bewar') + '/bewar_config.ini')['admins']:
        menu.send(userid)

""" EventScripts Main-Control functions """
# ------------
# Create the main-menu and register the client-command.
# ------------
def load():
    global menu
    es.ServerVar('bewar_ver', '2.0').makepublic()
    menu = popuplib.create('bewar_menu')
    menu.addline('BEWar - Admin Menu')
    menu.addline('------------')
    menu.addline(' ')
    menu.addline('->1. Change Max Rounds')
    menu.addline('->2. Execute Configs')
    menu.addline('->3. Knives On 3')
    menu.addline('->4. Live On 3')
    menu.addline('->5. Change Options')
    menu.addline(' ')
    menu.addline('0. Close')
    menu.menuselect = menuSelect
    es.regclientcmd('admin', 'bewar/admin')

# ------------
# Delete menus, un-register the client-command, enable buy-functions for players.
# ------------
def unload():
    name = 'bewar_submenu'
    if popuplib.exists(name):
        popuplib.delete(name)
    menu.delete()
    es.unregclientcmd('admin')
    for x in es.getUseridList():
        player(x).funcs('disable')

""" End Code """